using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace MouseWatcher
{
	/// <summary>
	/// Summary description for MouseWatcher.
	/// </summary>
	public class MouseWatcher : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public MouseWatcher()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.exitMenuItem = new System.Windows.Forms.MenuItem();
			this.moveMenuItem = new System.Windows.Forms.MenuItem();
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.exitMenuItem,
																						 this.moveMenuItem});
			// 
			// exitMenuItem
			// 
			this.exitMenuItem.Index = 0;
			this.exitMenuItem.Text = "Exit";
			this.exitMenuItem.Click += new System.EventHandler(this.exitItem_Click);
			// 
			// moveMenuItem
			// 
			this.moveMenuItem.Index = 1;
			this.moveMenuItem.Text = "Move";
			this.moveMenuItem.Click += new System.EventHandler(this.moveMenuItem_Click);
			// 
			// MouseWatcher
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(112, 131);
			this.ContextMenu = this.contextMenu1;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
			this.Name = "MouseWatcher";
			this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.MouseWatcher_MouseDown);
			this.Load += new System.EventHandler(this.MouseWatcher_Load);
			this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.MouseWatcher_MouseUp);
			this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.MouseWatcher_MouseMove);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MouseWatcher());
		}

		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem exitMenuItem;
		private System.Timers.Timer timer;
		private System.Windows.Forms.MenuItem moveMenuItem;
		private bool moveIt = false;
		private int height = 100;
		private int width = 100;

		private Watcher theWatcher;

		private void fire(Object sender, System.Timers.ElapsedEventArgs e)
		{
			Point point = PointToClient(MousePosition);
			theWatcher.watchLocation = point;
			Refresh();
		}

		private void MouseWatcher_Load(object sender, System.EventArgs e)
		{
			ShowInTaskbar = false;
			TopMost = true;
			SetVisibleCore(true);
			SetBounds(0, 0, width, height);

			System.Drawing.Drawing2D.GraphicsPath grPath =
					new System.Drawing.Drawing2D.GraphicsPath();
			grPath.AddEllipse(0, 0, width, height);
			Region = new Region(grPath);
			SetStyle(ControlStyles.AllPaintingInWmPaint, true);
			SetStyle(ControlStyles.DoubleBuffer, true);
			theWatcher = new Watcher();
			timer = new System.Timers.Timer(1);
			timer.Elapsed += new System.Timers.ElapsedEventHandler(fire);
			timer.Start();
		}

		protected override void OnPaint(PaintEventArgs pe)
		{
			theWatcher.draw(pe.Graphics);
		}

		private void exitItem_Click(object sender, System.EventArgs e)
		{
			new Thread(new ThreadStart(this.runAndExit)).Start();
		}

		private void runAndExit()
		{
			timer.Close();
			Random rand = new Random();
			int i = 0;
			for (i = 0; i < 100; i++)
			{
				Left = rand.Next(600);
				Top = rand.Next(600);
				Thread.Sleep(10);
			}

			for (int j = 0; j < 100; j++)
			{
				Left = i + j;
				Top = i + j;
				Thread.Sleep(10);
			}

			for (i = 0; i < 50; i++)
			{
				theWatcher.watchLocation = new Point(rand.Next(100), rand.Next(100));
				Refresh();
				System.Drawing.Drawing2D.GraphicsPath grPath =
					new System.Drawing.Drawing2D.GraphicsPath();
				grPath.AddEllipse(i, i, width - 2 * i, height - 2 * i);
				Region = new Region(grPath);
				Thread.Sleep(100);
			}

			Close();
		}

		private void moveMenuItem_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("Click on the application and drag it to where ever you want");
		}

		private void MouseWatcher_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			moveIt = true;
		}

		private void MouseWatcher_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (moveIt == true)
			{
				Point point = PointToScreen(new Point(e.X, e.Y));
				SetBounds(point.X - (int)(width / 2.0), point.Y - (int)(height/2.0), width, height);
			}
		}

		private void MouseWatcher_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			moveIt = false;
		}
	}
}
